<template></template>

<script>
    import DatabaseFieldChanger from '../DatabaseFieldChanger.vue';

    export default {

        components: {
            'broject-database-fieldchanger': DatabaseFieldChanger,
        },

        props: {
            classname: {
                type: String,
                required: true,
            },

            entityId: {
                type: Number,
                required: true,
            },

            fieldname: {
                type: String,
                required: true,
            },

            value: {
                type: String,
                default: null,
            },

            disabled: {
                type: Boolean,
                default: false,
            },

            label: {
                type: String,
                default: null,
            },
        },

        data() {
            return {
                isChanging: false,
                oldValue: this.value,
                newValue: this.value,
            }
        },

        methods: {
            changeValueInDatabase() {
                if (this.oldValue !== this.newValue) {
                    this.isChanging = true;
                    this.$emit('changeInProgress');
                }
            },

            changeValueInVue(data) {
                this.isChanging = false;

                if (data && data.hasOwnProperty('value')) {
                    this.oldValue = data.value;
                    this.newValue = data.value;

                    this.$emit('newValue', this.newValue);
                }
            },

            handleFailedFieldChange(data) {
                this.isChanging = false;

                if (data && data.hasOwnProperty('value')) {
                    this.oldValue = data.value;
                    this.newValue = data.value;
                }
            }
        }

    }
</script>
